SystemOrganization addCategory: #GODProcessors!

Object subclass: #PCSInformationRetrieval
	instanceVariableNames: 'dataStore indexes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSInformationRetrieval methodsFor: 'adding' stamp: 'TD 9/27/2014 18:05'!
add: aElement
	"add element to the dataStore and update index"
	! !

!PCSInformationRetrieval methodsFor: 'accessing' stamp: 'TD 9/27/2014 17:03'!
dataStore
	^dataStore! !

!PCSInformationRetrieval methodsFor: 'accessing' stamp: 'TD 9/27/2014 17:04'!
dataStore: aSet
	dataStore:= aSet.! !

!PCSInformationRetrieval methodsFor: 'initializing' stamp: 'TD 9/27/2014 16:45'!
initialize
	dataStore := Set new.
	indexes := Set new.! !

!PCSInformationRetrieval methodsFor: 'running' stamp: 'TD 9/27/2014 18:17'!
query: aCollection 
	"this method must be renamed to search:"
	"obs: I couldn't delete it, so I redirect it to search:"

	|auxCollection|
	auxCollection := self search: aCollection.
	^auxCollection.! !

!PCSInformationRetrieval methodsFor: 'running' stamp: 'TD 9/27/2014 18:13'!
search: aQuery
	"return a collection of GODData from the dataStore ordered according to the query"
	^nil! !

!PCSInformationRetrieval methodsFor: 'running' stamp: 'TD 9/27/2014 18:18'!
updateIndex
	"method must update the index"
	"must be used after add new data to the storeData"
	^nil! !

Object subclass: #PCSProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSProcessor commentStamp: 'FCB 10/2/2014 16:24' prior: 0!
Superclass of package GODProcessors!

PCSProcessor subclass: #CALLAcademicInformationAnalizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

PCSProcessor subclass: #PCSStatisticsCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 14:30'!
average: aCollection 
	"compute the average of the collection of real numbers"
	^aCollection average.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/7/2014 19:38'!
average: aCollection key: aKey
	"compute the average of key in the collection"
	| aNumberCollection |
	
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self average: aNumberCollection.! !

!PCSStatisticsCalculator methodsFor: 'counters' stamp: 'TD 10/19/2014 10:56'!
countIn: aString
	"return a Dictionary with the number of ocurrences of each word in aString"
	|aCollection  aSet aDictionary|
	aCollection := Array new.
	aSet := Set new.
	aDictionary := Dictionary new. 

	aCollection := aString  subStrings. 
	aSet := aCollection asSet.
	aSet do: [ :aSubString | aDictionary add: (Association key: aSubString value: (aCollection occurrencesOf: aSubString)).].

	 ^aSet! !

!PCSStatisticsCalculator methodsFor: 'counters' stamp: 'TD 10/14/2014 13:43'!
countIn: aString ocurrencesOf: aWord
	"return the number of ocurrences of aWord in aString"

	| |
	^nil! !

!PCSStatisticsCalculator methodsFor: 'initializing' stamp: 'TD 9/27/2014 13:35'!
initialize
	! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 14:22'!
median: aCollection 
	"compute the median of the collection of Number"
	^nil.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 13:55'!
median: aCollection key: aKey
	"compute the median of this key(k) in the collection(c)"
	^nil.

	! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 15:29'!
std: aCollection 
	"compute the standard deviation of the collection"
	^nil.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 15:29'!
std: aCollection key: aKey
	"compute the standard deviation of key in the collection"
	^nil.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 15:30'!
var: aCollection 
	"compute the variance of the collection"
	^nil.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 15:30'!
var: aCollection key: aKey
	"compute the variance of the key in the collection"
	^nil.! !
